﻿Imports System
Imports System.Text
Imports System.Collections.Generic
Imports System.Linq
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports System.Runtime.Serialization

Namespace Tests
	<Serializable()>
	Public Class CubeRow
		Implements ISerializable
		' A CubeRow may have one of the data structures below populated.

		' Either a Dictonary of concatenated column dimension captions and CubeTupe objects
        Private cubeTupleDict As New Dictionary(Of String, CubeTuple)
        ' OrElse a Dictonary of additional row dimension captions and CubeRow objects
		Private cubeDict As Dictionary(Of String, CubeRow)

		Public Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
			Me.cubeTupleDict = CType(info.GetValue("CubeTupleList",GetType(Dictionary(Of String, CubeTuple))), Dictionary(Of String, CubeTuple))
			Me.cubeDict = CType(info.GetValue("CubeDict", GetType(Dictionary(Of String, CubeRow))), Dictionary(Of String, CubeRow))
		End Sub

		Public Sub setCubeDict(ByVal cubeDict As Dictionary(Of String, CubeRow))
			Me.cubeDict = cubeDict
		End Sub

		' Add a concatenated list column dimension caption and the MDX query result value to the CubeTuple Dictionary
		Public Sub AddTuple(ByVal columnName As String, ByVal columnValue As Object)
			cubeTupleDict.Add(columnName, New CubeTuple(columnName, columnValue))
		End Sub

		Public Function GetCubeDict() As Dictionary(Of String, CubeRow)
			Return cubeDict
		End Function

		Public Function GetCubeTupleSize() As Integer
			Return cubeTupleDict.Count
		End Function

		' Return a CubeTuple object from the CubeTupe Dictionary if it exists given the dimension column name.
		Public Function GetCubeTuple(ByVal columnName As String) As CubeTuple
			If Not cubeTupleDict.ContainsKey(columnName) Then
				Return Nothing
			Else
				Return cubeTupleDict(columnName)
			End If
		End Function

		#Region "ISerializable Members"

		Public Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext) Implements ISerializable.GetObjectData
			info.AddValue("CubeTupleList", cubeTupleDict)
			info.AddValue("CubeDict", cubeDict)
		End Sub

		#End Region

		' Removes a CubeTuple from the CubeTuple Dictionary        
		Public Sub RemoveCubeTuple(ByVal columnName As String)
			cubeTupleDict.Remove(columnName)
		End Sub
	End Class
End Namespace
