﻿Imports System
Imports System.Text
Imports System.Collections.Generic
Imports System.Linq
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace Tests
	<TestClass>
	Public Class PurchaseCubeTest
		Inherits BaseMDXTest
		Public Sub New()
			MyBase.New("Data Source=devxrdb;Initial Catalog=PurchaseTest;", AppDomain.CurrentDomain.BaseDirectory)
		End Sub

		<TestInitialize>
		Public Sub InitializeCube()
			Dim xmlaToCube As New XMLAtoCube("c:\CubeDefinition")
			Dim sourceServerName As String = "devxrdb"
			Dim targetServerName As String = "devxrdb"
			Dim sourceDatabaseName As String = "Purchase"
			Dim targetDatabaseName As String = "PurchaseTest"
			Dim targetDataSourceConnectionString As String = "Provider=SQLNCLI11.1;Data Source=DEVXRDB;Integrated Security=SSPI;Initial Catalog=sacdw_data_mark"
			xmlaToCube.CreateCubeFromXMLA(sourceServerName, targetServerName, sourceDatabaseName, targetDatabaseName, targetDataSourceConnectionString)
		End Sub

		<TestMethod>
		Public Sub TestPurchaseCubeSingleRowAndColumn()
			' Query the number of items purchased by each customer regardless of time.
			Dim MDXQuerySingle As String = "select {[Customer].[CustomerName].members} on 0," & ControlChars.CrLf & "	                                {[Item].[ItemName].members} on 1 " & ControlChars.CrLf & "                                    from " & ControlChars.CrLf & "                                    [PurchaseCube]"
			Dim result As Boolean = TestMDXQuery("TestPurchaseCubeSingleRowAndColumn", MDXQuerySingle)
			Assert.IsTrue(result)
		End Sub

		<TestMethod>
		Public Sub TestPurchaseCubeMultipleRowsAndColumns()
			' Query the number of items bought at each store location for each day of the year.
			Dim MDXQuerySingle As String = "select {{EXCEPT([PurchaseDate].[Year].members," & ControlChars.CrLf & "                                                    [PurchaseDate].[Year].[All])}*" & ControlChars.CrLf & "                                            {EXCEPT([PurchaseDate].[Month].members," & ControlChars.CrLf & "                                                    [PurchaseDate].[Month].[All])}*" & ControlChars.CrLf & "                                            {EXCEPT([PurchaseDate].[Day].members," & ControlChars.CrLf & "                                                    [PurchaseDate].[Day].[All])}} on 0," & ControlChars.CrLf & "                                           {{EXCEPT([StoreLocation].[State].members," & ControlChars.CrLf & "                                                    [StoreLocation].[State].[All])}*" & ControlChars.CrLf & "                                            {EXCEPT([Item].[ItemName].members," & ControlChars.CrLf & "                                                    [Item].[ItemName].[All])}} on 1" & ControlChars.CrLf & "                                           from" & ControlChars.CrLf & "                                           [PurchaseCube]"
			Dim result As Boolean = TestMDXQuery("TestPurchaseCubeMultipleRowsAndColumns", MDXQuerySingle)
			Assert.IsTrue(result)
		End Sub
	End Class
End Namespace
